
  public clone_created(original_entity_id:string, clone_entity_id:string) : void {
    this._clone_id_2_original_id[clone_entity_id] = original_entity_id;
    if (!this.original_id_2_clone_id_list[original_entity_id]) {
      this.original_id_2_clone_id_list[original_entity_id] = [];
    }

    this.original_id_2_clone_id_list[original_entity_id].push(clone_entity_id);

    if (this.per_entity_clone_limit == undefined) { return; }

    const clone_list = this.original_id_2_clone_id_list[original_entity_id];
    const n_too_many = clone_list.length - this.per_entity_clone_limit;

    for (let i = 0; i < n_too_many; i++) {
      this.event_bus.clones.dispose_clone.send(
        clone_list[i],
      );
    }
  }
